# coding: utf-8

"""
    Barion API

    Integrate with ease and get unbeatable fees and data that helps you grow your business.

    The version of the OpenAPI document: 1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from clientapi_barion.models.currency import Currency
from clientapi_barion.models.transaction_status import TransactionStatus
from typing import Optional, Set
from typing_extensions import Self

class ProcessedTransaction(BaseModel):
    """
    ProcessedTransaction
    """ # noqa: E501
    pos_transaction_id: Optional[StrictStr] = Field(default=None, description="Unique identifier of the transaction at the shop.", alias="POSTransactionId")
    transaction_id: Optional[StrictStr] = Field(default=None, description="Unique identifier of the transaction generated by Barion.", alias="TransactionId")
    status: Optional[TransactionStatus] = Field(default=None, alias="Status")
    currency: Optional[Currency] = Field(default=None, description="3 character ISO 4217 currency code.", alias="Currency")
    transaction_time: Optional[datetime] = Field(default=None, description="Timestamp of the transaction.", alias="TransactionTime")
    __properties: ClassVar[List[str]] = ["POSTransactionId", "TransactionId", "Status", "Currency", "TransactionTime"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ProcessedTransaction from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if status (nullable) is None
        # and model_fields_set contains the field
        if self.status is None and "status" in self.model_fields_set:
            _dict['Status'] = None

        # set to None if currency (nullable) is None
        # and model_fields_set contains the field
        if self.currency is None and "currency" in self.model_fields_set:
            _dict['Currency'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ProcessedTransaction from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "POSTransactionId": obj.get("POSTransactionId"),
            "TransactionId": obj.get("TransactionId"),
            "Status": obj.get("Status"),
            "Currency": obj.get("Currency"),
            "TransactionTime": obj.get("TransactionTime")
        })
        return _obj


